/* Elvira Bluetooth FTP 
 * Copyright (C) 2007  Alberto Salas Bragado
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "common_gtk.h"

void l(char *cadena) {
	
	char *final;
	GtkTextBuffer *buffer;
	GtkTextIter start;
	time_t ts;
	char fecha[30];

	ts = time(NULL);
	strftime(fecha, 30, "%H:%M:%S", localtime(&ts));

	final = (char *) malloc(strlen(cadena)+strlen(fecha)+5);
	sprintf(final, "[%s] %s\n", fecha, cadena);

	buffer = gtk_text_view_get_buffer(logWidget);
	gtk_text_buffer_get_start_iter(buffer, &start);
	gtk_text_buffer_insert(buffer, &start, final, -1);

	free(final);

	//FLUSH
	while (gtk_events_pending())
		gtk_main_iteration();
	
}

void initWidgets() {
	
	GladeXML *xml;

	/* Cargar la interfaz de usuario */
	xml = glade_xml_new(FGLADE, "mainWindow", NULL);

	/* Obtener referencias a los widgets */
	lstRemote = GTK_TREE_VIEW(glade_xml_get_widget(xml, "lstRemote"));
	g_assert(lstRemote != NULL);
	lstLocal = GTK_TREE_VIEW(glade_xml_get_widget(xml, "lstLocal"));
	g_assert(lstLocal != NULL);
	txtRemote = GTK_ENTRY(glade_xml_get_widget(xml, "txtRemote"));
	g_assert(txtRemote != NULL);
	txtLocal = GTK_ENTRY(glade_xml_get_widget(xml, "txtLocal"));
	g_assert(txtLocal != NULL);
	btnConectar = GTK_TOGGLE_TOOL_BUTTON(glade_xml_get_widget(xml,
			"btnConectar"));
	g_assert(txtLocal != NULL);
	logWidget = GTK_TEXT_VIEW(glade_xml_get_widget(xml, "log"));
	g_assert(logWidget != NULL);

	/* Preparar listados de ficheros */
	prepareFileList(lstLocal);
	prepareFileList(lstRemote);

	/* Conectar las señales de la interfaz */
	glade_xml_signal_autoconnect(xml);

	/* Ahora cargamos la ventana de conexión para poder mostrarla en cualquier momento */
	xml = glade_xml_new(FGLADE, "connWindow", NULL);
	connWindow = GTK_WINDOW(glade_xml_get_widget(xml, "connWindow"));
	g_assert(connWindow != NULL);
	gtk_widget_hide((GtkWidget *)connWindow);
	lstFavoritos = GTK_TREE_VIEW(glade_xml_get_widget(xml, "lstFavoritos"));
	g_assert(lstFavoritos != NULL);
	lstBusqueda = GTK_TREE_VIEW(glade_xml_get_widget(xml, "lstBusqueda"));
	g_assert(lstBusqueda != NULL);
	prepareDispList(lstBusqueda);
	prepareDispList(lstFavoritos);
	glade_xml_signal_autoconnect(xml);

	/* Cargamos el diálogo de error y su etiqueta */
	xml = glade_xml_new(FGLADE, "errorDialog", NULL);
	errorDialog = GTK_DIALOG(glade_xml_get_widget(xml, "errorDialog"));
	g_assert(errorDialog != NULL);
	gtk_widget_hide((GtkWidget *)errorDialog);
	txtError = GTK_LABEL(glade_xml_get_widget(xml, "txtError"));
	glade_xml_signal_autoconnect(xml);

	/* Cargamos el diálogo de confirmacion de eliminacion de fichero */
	xml = glade_xml_new(FGLADE, "delDialog", NULL);
	delDialog = GTK_DIALOG(glade_xml_get_widget(xml, "delDialog"));
	g_assert(delDialog != NULL);
	gtk_widget_hide((GtkWidget *)delDialog);
	glade_xml_signal_autoconnect(xml);

	/* Cargamos el diálogo de nombre de directorio a crear */
	xml = glade_xml_new(FGLADE, "newDirDialog", NULL);
	newDirDialog = GTK_DIALOG(glade_xml_get_widget(xml, "newDirDialog"));
	g_assert(newDirDialog != NULL);
	gtk_widget_hide((GtkWidget *)newDirDialog);
	txtNewDir = GTK_ENTRY(glade_xml_get_widget(xml, "txtNewDir"));
	g_assert(txtNewDir != NULL);
	glade_xml_signal_autoconnect(xml);
	
	/* Cargamos el dialogo acerca de... */
	xml = glade_xml_new(FGLADE, "aboutDialog", NULL);
	aboutDialog = GTK_DIALOG(glade_xml_get_widget(xml, "aboutDialog"));
	g_assert(aboutDialog != NULL);
	gtk_widget_hide((GtkWidget *)aboutDialog);
	glade_xml_signal_autoconnect(xml);
	
	/* Ahora cargamos la ventana de conexión para poder mostrarla en cualquier momento */
	xml = glade_xml_new(FGLADE, "progressDialog", NULL);
	progressDialog = GTK_WINDOW(glade_xml_get_widget(xml, "progressDialog"));
	g_assert(connWindow != NULL);
	gtk_widget_hide((GtkWidget *)progressDialog);
	lblProgress = GTK_LABEL(glade_xml_get_widget(xml, "lblProgreso"));
	g_assert(lblProgress != NULL);
	lblFile = GTK_LABEL(glade_xml_get_widget(xml, "lblFichero"));
	g_assert(lblFile != NULL);
	glade_xml_signal_autoconnect(xml);

	/* Liberamos el objeto xml */
	g_object_unref(G_OBJECT(xml));
	
}

void poblateFileList(GtkTreeView *gtv, file_t *files, int numfiles, int root) {
	
	GtkListStore *model;
	GtkTreeIter iter;
	GdkPixbuf *pixbuf;
	int indice;

	//Obtener el modelo que usa el treeview
	model = GTK_LIST_STORE(gtk_tree_view_get_model(gtv));
	//Desasignarlo para acelerar el poblado
	gtk_tree_view_set_model(gtv, NULL);
	//Vaciar el modelo antes de empezar
	gtk_list_store_clear(model);

	//Añadir ".." para subir de directorio
	if (!root) {
		gtk_list_store_append(model, &iter);
		pixbuf = gdk_pixbuf_new_from_file("res/folder.gif", NULL);
		gtk_list_store_set(model, &iter, COLUMN1, pixbuf, COLUMN2, "..", COLUMN3, FILET_FOLDER, COLUMN4, "", -1);
	}

	//Recorrer el listado de ficheros
	for (indice=0; indice<numfiles; indice++) {
		//Añadir una fila al modelo
		gtk_list_store_append(model, &iter);
		//Crear el objeto imagen
		if (files[indice].type == FILET_FOLDER) {
			pixbuf = gdk_pixbuf_new_from_file("res/folder.gif", NULL);
			gtk_list_store_set(model, &iter, COLUMN1, pixbuf, COLUMN2, files[indice].name, COLUMN3, FILET_FOLDER, COLUMN4, files[indice].size, -1);
		} else {
			pixbuf = gdk_pixbuf_new_from_file("res/file.gif", NULL);
			gtk_list_store_set(model, &iter, COLUMN1, pixbuf, COLUMN2, files[indice].name, COLUMN3, FILET_FILE, COLUMN4, files[indice].size, -1);
		}

	}
	
	//Volver a asignar el modelo a la vista
	gtk_tree_view_set_model(gtv, GTK_TREE_MODEL(model));
}

void poblateDeviceList(GtkTreeView *gtv, device_t *devices, int numdevices) {
	GtkListStore *model;
	GtkTreeIter iter;
	int indice;

	//Obtener el modelo que usa el treeview
	model = GTK_LIST_STORE(gtk_tree_view_get_model(gtv));
	//Desasignarlo para acelerar el poblado
	gtk_tree_view_set_model(gtv, NULL);
	//Vaciar el modelo antes de empezar
	gtk_list_store_clear(model);

	//Recorrer el listado de ficheros
	for (indice=0; indice<numdevices; indice++) {
		
		//Añadir una fila al modelo
		gtk_list_store_append(model, &iter);
		//Crear el objeto imagen
		gtk_list_store_set(model, &iter, DCOLUMN1, devices[indice].name, DCOLUMN2, devices[indice].mac, DCOLUMN3, devices[indice].port, -1);

	}

	//Volver a asignar el modelo a la vista
	gtk_tree_view_set_model(gtv, GTK_TREE_MODEL(model));
}

void disconnectProcessGui() {

	GtkListStore *model;

	//Obtener el modelo que usa el treeview
	model = GTK_LIST_STORE(gtk_tree_view_get_model(lstRemote));
	//Vaciar el modelo
	gtk_list_store_clear(model);

	//Obtener el modelo que usa el treeview
	model = GTK_LIST_STORE(gtk_tree_view_get_model(lstLocal));
	//Vaciar el modelo
	gtk_list_store_clear(model);

	//Vaciar las cajas de texto
	gtk_entry_set_text(txtLocal, "");
	gtk_entry_set_text(txtRemote, "");
	
}

int obtenerFactorOrdenacion(GtkTreeModel *model);
gint sort_name_compare_func (GtkTreeModel *model, GtkTreeIter *a, GtkTreeIter *b, gpointer userdata);
gint sort_tam_compare_func (GtkTreeModel *model, GtkTreeIter *a, GtkTreeIter *b, gpointer userdata);

/* http://scentric.net/tutorial/ */
void prepareFileList(GtkTreeView *gtv) {
	GtkListStore *model;
	GtkTreeViewColumn *col;
	GtkCellRenderer *renderer;
	GtkTreeSelection *selection;
	GtkTreeSortable *sortable;

	//Columna de nombre
	col = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(col, "Nombre");
	/* pack tree view column into tree view */
	gtk_tree_view_append_column(gtv, col);
	/* create cell renderer pixbuf */
	renderer = gtk_cell_renderer_pixbuf_new();
	gtk_tree_view_column_pack_start(col, renderer, FALSE);
	gtk_tree_view_column_set_attributes(col, renderer, "pixbuf", COLUMN1, NULL);
	/* create cell renderer */
	renderer = gtk_cell_renderer_text_new();
	/* pack cell renderer into tree view column */
	gtk_tree_view_column_pack_start(col, renderer, TRUE);
	/* set 'text' property of the cell renderer */
	gtk_tree_view_column_add_attribute(col, renderer, "text", COLUMN2);
	/* ordenacion de columna */
	gtk_tree_view_column_set_sort_column_id(col, COLUMN2);
	
	//Columna de tamaño
	col = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(col, "Tamaño (Bytes)");
	/* pack tree view column into tree view */
	gtk_tree_view_append_column(gtv, col);
	/* create cell renderer */
	renderer = gtk_cell_renderer_text_new();
	/* pack cell renderer into tree view column */
	gtk_tree_view_column_pack_start(col, renderer, TRUE);
	/* set 'text' property of the cell renderer */
	gtk_tree_view_column_add_attribute(col, renderer, "text", COLUMN4);
	/* ordenacion de columna */
	gtk_tree_view_column_set_sort_column_id(col, COLUMN4);

	//INICIAR MODELO
	//Crear modelo
	model = gtk_list_store_new(NUMCOLUMNS, GDK_TYPE_PIXBUF, G_TYPE_STRING,
			G_TYPE_INT, G_TYPE_STRING);
	
	//Configurar la ordenacion del modelo
	sortable = GTK_TREE_SORTABLE(model);
	gtk_tree_sortable_set_sort_func(sortable, COLUMN2, sort_name_compare_func, NULL, NULL);
	gtk_tree_sortable_set_sort_func(sortable, COLUMN4, sort_tam_compare_func, NULL, NULL);
	gtk_tree_sortable_set_sort_column_id(sortable, COLUMN2, GTK_SORT_ASCENDING);
	
	//Asignar el modelo a la vista
	gtk_tree_view_set_model(gtv, GTK_TREE_MODEL(model));

	//Seleccionar SELECCION MULTIPLE
	selection = gtk_tree_view_get_selection(gtv);
	gtk_tree_selection_set_mode(selection, GTK_SELECTION_MULTIPLE);
}

void prepareDispList(GtkTreeView *gtv) {
	GtkListStore *model;
	GtkTreeViewColumn *col;
	GtkCellRenderer *renderer;

	//Columna de nombre corto
	col = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(col, "Nombre Corto");
	/* pack tree view column into tree view */
	gtk_tree_view_append_column(gtv, col);
	/* create cell renderer */
	renderer = gtk_cell_renderer_text_new();
	/* pack cell renderer into tree view column */
	gtk_tree_view_column_pack_start(col, renderer, TRUE);
	/* set 'text' property of the cell renderer */
	gtk_tree_view_column_add_attribute(col, renderer, "text", DCOLUMN1);

	//Columna de direccion MAC
	col = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(col, "MAC");
	/* pack tree view column into tree view */
	gtk_tree_view_append_column(gtv, col);
	/* create cell renderer */
	renderer = gtk_cell_renderer_text_new();
	/* pack cell renderer into tree view column */
	gtk_tree_view_column_pack_start(col, renderer, TRUE);
	/* set 'text' property of the cell renderer */
	gtk_tree_view_column_add_attribute(col, renderer, "text", DCOLUMN2);

	//Columna de nombre corto
	col = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(col, "Puerto");
	/* pack tree view column into tree view */
	gtk_tree_view_append_column(gtv, col);
	/* create cell renderer */
	renderer = gtk_cell_renderer_text_new();
	/* pack cell renderer into tree view column */
	gtk_tree_view_column_pack_start(col, renderer, TRUE);
	/* set 'text' property of the cell renderer */
	gtk_tree_view_column_add_attribute(col, renderer, "text", DCOLUMN3);

	//INICIAR MODELO
	//Crear modelo
	model = gtk_list_store_new(DNUMCOLUMNS, G_TYPE_STRING, G_TYPE_STRING,
			G_TYPE_INT);
	//Asignar el modelo a la vista
	gtk_tree_view_set_model(gtv, GTK_TREE_MODEL(model));

}

void getFilesSelected(GtkTreeView *gtv, file_t **files, int *numfiles) {
	
	GtkTreeModel *model;
	GtkTreePath *path;
	GtkTreeIter iter;
	GList *selected, *seleciter;
	GtkTreeSelection *selection;
	file_t *lista=NULL;
	int num=0;
	
	//Inicializamos lo que vamos a devolver
	*files = NULL;
	
	//Obtenemos seleccion y modelo
	selection = gtk_tree_view_get_selection(gtv);
	selected = gtk_tree_selection_get_selected_rows(selection, NULL);
	model = gtk_tree_view_get_model(gtv);
	
	//Recorremos la selección de filas
	for (seleciter = g_list_first(selected); seleciter != NULL; seleciter = g_list_next(seleciter)) {

		//Obtenemos el path de la fila seleccionada actual
		path = (GtkTreePath *) seleciter->data;

		//Obtenemos el Iter a partir del path
		if (gtk_tree_model_get_iter(model, &iter, path)) {

			gchar *name;
			gint tipo;
			
			//Extraemos los datos de la fila actual del modelo
			gtk_tree_model_get(model, &iter, COLUMN2, &name, COLUMN3, &tipo, -1);
			
			//Ampliamos la memoria para añadir el fichero
			num++;
			lista = (file_t *) realloc (lista, sizeof(file_t)*num);
			
			//Rellenamos el fichero nuevo
			lista[num-1].type = tipo;
			strcpy(lista[num-1].name, name);
			
			g_free(name);

		}
	}

	//Liberar memoria de la selección
	g_list_free(selected);
	g_list_free(seleciter);
	
	//Devolvemos la lista de ficheros
	*files = lista;
	*numfiles = num;
	
}

void getDeviceSelected(GtkTreeView *gtv, device_t *device) {
	
	GtkTreeSelection *selection;
	GtkTreeModel *model;
	GtkTreeIter iter;

	selection = gtk_tree_view_get_selection(gtv);

	if (gtk_tree_selection_get_selected(selection, &model, &iter)) {

		gchar *nombre, *mac;
		gint puerto;

		gtk_tree_model_get(model, &iter, DCOLUMN1, &nombre, DCOLUMN2, &mac, DCOLUMN3, &puerto, -1);

		strcpy(device->name, nombre);
		strcpy(device->mac, mac);
		device->port = puerto;
		
		g_free(nombre);
		g_free(mac);
		
	}
	
}

void getFileActivated(GtkTreeView *gtv, GtkTreePath *path, file_t *file) {
	
	GtkTreeModel *model;
	GtkTreeIter iter;
		
	model = gtk_tree_view_get_model(gtv);

	if (gtk_tree_model_get_iter(model, &iter, path)) {
		
		gchar *name;
		gint tipo;

		gtk_tree_model_get(model, &iter, COLUMN2, &name, COLUMN3, &tipo, -1);
		
		file->type = tipo;
		strcpy(file->name, name);
		
		g_free(name);
	}
	
}

void getTextEntry(GtkEntry *entry, char *cad) {
	
	const gchar *texto;
	texto = gtk_entry_get_text(entry);
	strcpy(cad, texto);
	
}

void addDeviceList(GtkTreeView *gtv, device_t *device) {
	GtkListStore *model;
	GtkTreeIter iter;

	//Obtener el modelo que usa el treeview
	model = GTK_LIST_STORE(gtk_tree_view_get_model(gtv));

	//Añadir una fila al modelo
	gtk_list_store_append(model, &iter);
	//Crear el objeto imagen
	gtk_list_store_set(model, &iter, DCOLUMN1, device->name, DCOLUMN2, device->mac, DCOLUMN3, device->port, -1);

}

void delDeviceList(GtkTreeView *gtv) {
	GtkTreeSelection *selection;
	GtkTreeModel *model;
	GtkTreeIter iter;

	selection = gtk_tree_view_get_selection(gtv);

	if (gtk_tree_selection_get_selected(selection, &model, &iter)) {

		gtk_list_store_remove(GTK_LIST_STORE(model), &iter);

	}
}

void updateGUI() {
	while (gtk_events_pending())
	   gtk_main_iteration();
}

void getDevicesGTV(GtkTreeView *gtv, device_t **devices, int *numdevices) {
	GtkTreeModel *model;
	GtkTreeIter iter;
	device_t *lista=NULL;
	int num=0;

	//Obtener el modelo que usa el treeview
	model = gtk_tree_view_get_model(gtv);
	
	if (gtk_tree_model_get_iter_first(model, &iter) == FALSE) {
		//Arbol vacío
		*devices = NULL;
		*numdevices = 0;
		return;
	}
	
	do {
		
		gchar *nombre, *mac;
		gint puerto;

		gtk_tree_model_get(model, &iter, DCOLUMN1, &nombre, DCOLUMN2, &mac, DCOLUMN3, &puerto, -1);
		
		lista = (device_t *) realloc(lista, ++num * sizeof(device_t));

		strcpy(lista[num-1].name, nombre);
		strcpy(lista[num-1].mac, mac);
		lista[num-1].port = puerto;
		
		g_free(nombre);
		g_free(mac);		
		
	} while (gtk_tree_model_iter_next(model, &iter) != FALSE);
	
	*devices = lista;
	*numdevices = num;
	
}

/**
 * Calculo del factor de ordenacion para el caso especial ".."
 * en la ordenacion de ficheros
 */
int obtenerFactorOrdenacion(GtkTreeModel *model) {
	//interfaz de ordenacion
	GtkTreeSortable *sortable;
	//sentido de la odenacion
	GtkSortType order;
	//campo por el que la lista esta ordenada
	gint sortid;
	
	//Obtengo la ordenacion actual del modelo y calculo el factor
	sortable = GTK_TREE_SORTABLE(model);
	if (gtk_tree_sortable_get_sort_column_id(sortable, &sortid, &order)
			&& (order == GTK_SORT_DESCENDING))
		return -1;
	else
		return 1;
}

/**
 * Ordenacion por nombre de fichero
 * Primero los directorios y luego los ficheros
 * Cada uno de estos grupos ordenado por la funcion strcasecmp
 */
gint sort_name_compare_func (GtkTreeModel *model, GtkTreeIter *a, GtkTreeIter *b, gpointer userdata) {
	
	//variables auxiliares
	gchar *name1, *name2;
	gint tipo1, tipo2;
	int res=0, factor;
	
	//Obtengo los datos del nombre y tipo en el modelo
	gtk_tree_model_get(model, a, COLUMN2, &name1, COLUMN3, &tipo1, -1);
	gtk_tree_model_get(model, b, COLUMN2, &name2, COLUMN3, &tipo2, -1);
	
	//Obtengo el factor de ordenacion
	factor = obtenerFactorOrdenacion(model);	
	
	//Primero compruebo el caso especial ".." que siempre ira al principio de la lista
	if (strcmp(name1, "..") == 0) {
		res = -1 * factor;
	} else if (strcmp(name2, "..") == 0) {
		res = 1 * factor;
	//Si son del mismo tipo se ordenan por la funcion strcasecmp
	} else if (tipo1 == tipo2) {
		res = strcasecmp(name1, name2);
	//Si son de distinto tipo, el directorio va primero
	} else if (tipo2 == FILET_FOLDER) {
		res = 1;
	} else {
		res = -1;
	}
	
	//libero las cadenas
	g_free(name1); g_free(name2);
	//retorno el resultado
	return res;
	
}

/**
 * Ordenacion por tamaño de fichero
 */
gint sort_tam_compare_func (GtkTreeModel *model, GtkTreeIter *a, GtkTreeIter *b, gpointer userdata) {
	
	gchar *tam1, *tam2, *name1, *name2;
	int res, factor;
	
	//Obtengo los datos del nombre y tamaño en el modelo
	gtk_tree_model_get(model, a, COLUMN2, &name1, COLUMN4, &tam1, -1);
	gtk_tree_model_get(model, b, COLUMN2, &name2, COLUMN4, &tam2, -1);
	
	//Obtengo el factor de ordenacion
	factor = obtenerFactorOrdenacion(model);	
	
	//Primero compruebo el caso especial ".." que siempre ira al principio de la lista
	if (strcmp(name1, "..") == 0) {
		res = -1 * factor;
	} else if (strcmp(name2, "..") == 0) {
		res = 1 * factor;
	//Si los tamaños son iguales, ordenamos por nombre
	} else if (strcmp(tam1, tam2) == 0) {
		res = sort_name_compare_func(model, a, b, NULL);		
	//Si se trata de una cadena vacía la colocamos antes que cualquier numero
	} else if (strcmp(tam1, "") == 0) {
		res = 1;
	} else if (strcmp(tam2, "") == 0) {
		res = -1;
	//Los casos restante son comparacion de dos numeros
	} else if (atoi(tam1) > atoi(tam2)) {
		res = -1;
	} else if (atoi(tam1) < atoi(tam2)) {
		res = 1;
	} else {
		res = 0;
	}
	
	//Liberamos las cadenas
	g_free(tam1); g_free(tam2); g_free(name1); g_free(name2);
	
	//Devolvemos el resultado
	return res;
}
